package ru.dbotthepony.mc.otm.mixin;

import net.minecraft.sounds.SoundSource;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.projectile.AbstractHurtingProjectile;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import ru.dbotthepony.mc.otm.capability.IMatteryPlayer;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.registry.MSoundEvents;

@Mixin(AbstractHurtingProjectile.class)
public class MixinAbstractHurtingProjectile {
	@Inject(
		method = "onDeflection(Lnet/minecraft/world/entity/Entity;Z)V",
		remap = false,
		at = @At("TAIL")
	)
	public void onDeflection(Entity entity, boolean byAttack, CallbackInfoReturnable<Boolean> cir) {
		if (entity instanceof IMatteryPlayer player) {
			var cap = player.getOtmPlayer();

			AbstractHurtingProjectile proj = (AbstractHurtingProjectile)(Object)this;

			if (cap.isAndroid() && proj.getOwner() != entity) {
				entity.level().playSound(entity, proj.blockPosition(), MSoundEvents.INSTANCE.getANDROID_PROJ_PARRY(), SoundSource.PLAYERS, 1.0f, 0.95f + entity.level().random.nextFloat() * 0.1f);
			}
		}
	}
}
